function [retval] = computeEnergy(x,y,parameters)
%sum of individual peaks, calls g
[m,n] = size(parameters);
retval = 0;
for i = 1:m
  retval = retval + computeEnergyTerm(x,y,parameters(i,1),parameters(i,2),parameters(i,3),parameters(i,4));
end


% now adding the folded state term
L = 19;  % the peak around folded state
K = 50;  % the pit at the folded state

r_o     = sqrt(K + L); % radius of the well
tau     = 10; % how quickly the energy barrier decays
s       = x .^ 2 + y .^ 2; % sqr of the sum.
sqrt_s  = sqrt (s);
if (sqrt_s < r_o)
  retval = retval + s - K;
else
  retval = retval + L * exp ( - (sqrt_s - r_o) / tau);
end



retval   = retval * 0.1;
%m       = 2; % to stretch the function
%s1      = (x ^ 2 + y ^ 2) / m ^ 2; 
%sqrt_s1 = sqrt(s); 

%this term does not have m
%s2      = (x ^ 2 + y ^ 2);
%sqrt_s2 = sqrt(s2);



% the well 
%tau    = 7; beta = 0.0; alpha = 15 * exp(1) * exp(1) / 4;
%fST    = (alpha * s1 / exp(sqrt_s1)) + beta * (1 - exp (- sqrt_s2 / tau)) - 50; 
% computed folded state term

%retval   = retval + fST;


