function newFoldedIndices   = findNewIndices(nodesInBiggestCC, ...
					     foldedIndices)
%given the biggest CC, and nodes in folded or unfolded macrostate,
%updates the node indices in the folded or unfolded macrostate and 
%returns the new indices.
%nodes in biggest CC and in foldedIndices
%are assumed to be 1-based.


numNodes        = length(nodesInBiggestCC);
if ~(all((foldedIndices >= 1)) & all((nodesInBiggestCC >= 1) ))
  error('findNewIndices: invalid node indices in the parameters');
end

origNodeIndices = sort(nodesInBiggestCC);

  
%now we have a mapping between original indices and new indices.
  
newFoldedIndices = []; 
   
for i = 1:length(foldedIndices)
  findResult = find(origNodeIndices == foldedIndices(i));
  if (length(findResult) ~= 0)
%      assuming that find returns 0 if it can't find a value in the ...
%	    array;
     newFoldedIndices = [newFoldedIndices ...
			 findResult];
     
  else
    fprintf(1, 'node # %d is not in the biggest cc but is in the folded or unfolded macrostate\n', foldedIndices(i));
%    keyboard;
  end
end
