function plotRoadmap(nodesFilename, connectionFilename)
% plots in 2D.
% plot the energy function
% reads the node coordinates
% plot them on top of the surface.

%needs parameters.txt in the current dir.
plotLandscape;
hold;

nodes = load (nodesFilename);
conn  = load (connectionFilename);

[m,n] = size(nodes);
X = zeros(m,1);
Y = zeros(m,1);
Z = zeros(m,1);
for i = 1: m
  X(i) = nodes(i,1);
  Y(i) = nodes(i,2);
  Z(i) = computeEnergy( X(i), Y(i), p);
end

plot3(X,Y,Z,'b+');


[r,q] = size(conn);
for i = 1 :r
  node_a = conn(i,1);                 %0-based numbers
  node_b = conn(i,2);
  if (node_a > node_b)
    continue;
  end
    %  lineX = [X(node_a+1) X(node_b+1)];
%  lineY = [Y(node_a+1) Y(node_b+1)];
%  lineZ = [f(lineX(1),lineY(1),p) f(lineX(2),lineY(2),p)];
  lineX  = [X(node_a+1)];
  lineY  = [Y(node_a+1)];
  lineZ  = [computeEnergy(lineX(1),lineY(1),p)];
  dx     = (X(node_b+1) - X(node_a+1))/2;
  dy     = (Y(node_b+1) - Y(node_a+1))/2;

  lastX = X(node_a+1); 
  lastY = Y(node_a+1);
  
  for j = 1: 2
      
	lastX = lastX + dx;
        lastY = lastY + dy;

	lineX = [lineX lastX];
	lineY = [lineY lastY];
	lineZ = [lineZ computeEnergy(lastX,lastY,p)];
  end	
	
%  plot3(lineX(2:length(lineX)-1),lineY(2:length(lineX)-1),lineZ(2:length(lineX)-1),'r*');
  plot3(lineX,lineY,lineZ,'k');
end
%rotate3d
