#ifndef _ANALYSIS_H
#define _ANALYSIS_H

#include <vector>
#include "matrix.H"

class Protein;

void computeAndPrintPfold (vector<Real> & pfolds, int numPfoldsRequested, 
			   int maxNumNeighbors, 
			   int runIndex,
			   float foldedMacrostateRMSDRadius, 
			   float unfoldedMacrostateRMSDRadius, 
			   int numberOfNodes,
			   Protein**  allNodes,
			   int foldedStateIndex, int unfoldedStateIndex,
			   const ccInfoType * ccInfo);

vector<int> computeCloseNodes(int centerNodeIndex, Protein ** allNodes, 
			      int numNodes,
			      float macrostateRMSDRadius);

unsigned int findNumNeighbors (int i, int numNodes, Protein ** allNodes);

void initNodeColor(const int numNodes, int thecolor, Protein ** allNodes);

#endif
