#include <vector>
#include <iostream>
using std::cout;
using std::endl;

#include <set>
using std::set;

#include "protein.H"
#include "roadmapConstruction.H"
#include "MCSimulation.H"
#include "ioRoutines.H"
#include "tree.H"

//can put debugging code here !


void checkProteinIndices(Protein ** allNodes, int numberOfNodes) {

  int i;
  
  for (i = 0;  i < numberOfNodes; i++) {
    assert(allNodes[i] ->getIndex() == i);
  }
}
/*
  checks whether the myNode entry of the nodes is NULL or not.
  I am not sure what the second part does.
*/
void checkNodes(Protein ** allNodes, int numberOfNodes)
{
  for (int i = 0;  i < numberOfNodes; i++) 
    {
      if (!(allNodes[i] ->myNode))
	{
	  cout << i  << "th nodes myNode is null" << endl;
	}
    }
}



void checkProteinEnergies      (Protein ** allNodes, int numberOfNodes)
{
  int i;
  
  for (i = 0; i < numberOfNodes; i++) 
    {
      if (allNodes[i]->getEnergy() > Protein::maxEnergy)
	{
	  cout << "i = " << i << " Energy = " << allNodes[i]->getEnergy() << " total energy = " << allNodes[i]->getEnergy() << endl;
	  assert(allNodes[i]->getEnergy() <= Protein::maxEnergy);
	}
    }
}

void checkProteins      (Protein ** allNodes, int numberOfNodes)
{
  checkProteinIndices(allNodes, numberOfNodes);
  checkProteinEnergies(allNodes, numberOfNodes);
  checkNodes(allNodes, numberOfNodes);
}


///
void testEdgeConnections(Protein ** allNodes, int numNodes, 
			 ccInfoType * ccInfo)
{
  vector<int> neighbors;

  writeNodes(allNodes, numNodes);
  
  cout << "before making any connections..." << endl;
  linkNodesStatPrintOuts(numNodes, allNodes, ccInfo);
  
  //initializekNN(numNodes, 4, 1, allNodes);
  makeLinkBetweenNodes(numNodes, 0, 1, allNodes, ccInfo);
  linkNodesStatPrintOuts(numNodes, allNodes, ccInfo);
  

  makeLinkBetweenNodes(numNodes, 2, 0, allNodes, ccInfo);
  linkNodesStatPrintOuts(numNodes, allNodes, ccInfo);

}

///
void sampleSomeGivenNodes(Protein ** allNodes, int *numberOfNodes)
{
  vector<float> coords(2);
  
  coords[0] = -50.0; coords[1] = -50.0;
      
  allNodes[*numberOfNodes] = new Protein(*numberOfNodes, coords);
  (*numberOfNodes) ++;

  coords[0] = -50.0; coords[1] = 50.0;
      
  allNodes[*numberOfNodes] = new Protein(*numberOfNodes, coords);
  (*numberOfNodes) ++;

  coords[0] = 90.0; coords[1] = -50.0;
      
  allNodes[*numberOfNodes] = new Protein(*numberOfNodes, coords);
  (*numberOfNodes) ++;

  coords[0] = 90.0; coords[1] = 50.0;
      
  allNodes[*numberOfNodes] = new Protein(*numberOfNodes, coords);
  (*numberOfNodes) ++;

  coords[0] = 0.0; coords[1] = 0.0;
      
  allNodes[*numberOfNodes] = new Protein(*numberOfNodes, coords);
  (*numberOfNodes) ++;
}


void testSomeFunctions(Protein ** allNodes, int numNodes, int maxNumNeighbors, 
		       ccInfoType * ccInfo)
{  
  /*  node index = 3071
      node index = 176
      node index = 2085
      node index = 1386
      node index = 1969
      node index = 2623
  */
  vector<int> f(1),u(2);
  f[0] = 3071; u[0] = 0; u[1] = 1;
  //int numPfoldsRequested = 176;
  vector<Real> pfolds;
  
  treeClass * t = findBiggestCC(ccInfo);
  cout << "biggest cc has " << t->numNodesInTree << " nodes." << endl;

}

