#ifndef IOROUTINES_H
#define IOROUTINES_H
#include <fstream>
//using std::
#include <vector>
using std::vector;
#include "matrix.H"
#include <string>
using std::string;

class ccInfoType;



//read routines


void readNodeCoords (const char * filename, 
		     vector<float> & xcoords,
		     vector<float> & ycoords);
int  readPresampledConformations(Protein ** allNodes, 
				int *numberOfNodes);
//write routines
void printPath(const vector<int>& path, Protein ** allNodes,
	       const string& filename);
void printPfolds    (const vector<Real>  & pfolds, int numNodes, int runIndex);
void linkNodesStatPrintOuts(int numNodes, 
			    Protein ** allNodes, ccInfoType * ccInfo);

void printCloseNodeIndices (int foldedStateIndex, int unfoldedStateIndex,
			    float minDistFolded, float minDistUnfolded, 
			    Protein ** allNodes, int numNodes,
			    int runIndex);
void writeConnections (Protein ** allNodes, int numNodes     , int runIndex);
void writeTransitionProbabilities(int numNodes, Protein ** allNodes, 
				  const char * filename);
void writeNodes(Protein ** allNodes, int numNodes);
void writeNodes       (Protein ** allNodes, int numberOfNodes, int runIndex);






//other helpers
void reportTimes (struct tms start, struct tms end);
void handleInput (int argc, char ** argv, int * numRandomNodes, 
		  int * index, int MAXNODES);
#endif
