#ifndef MATRIX_H
#define MATRIX_H


#include <vector>
using std::vector;

#include <set>
using std::set;

#include "mymatrix.h"
#include "mysparse.h"
#include "roadmapConstruction.H"

class Protein;


void computePfoldWrapper(vector<Real>& pfolds, 
			 int numNodes, Protein ** allNodes, 
			 int numPfoldsRequested, 
			 const vector<int>& foldedIndices,
			 const vector<int>& unfoldedIndices,
			 int maxNumNeighbors,
			 const ccInfoType * ccInfo);

void computeMapping (vector<int> & mapping, const vector<int>& foldedIndices, 
		     const vector<int>& unfoldedIndices, int numNodes, 
		     int inf);

bool contained (const vector<int> & indices, const set<int> & s);
bool contained (int n1, int n2, const set<int> & s);
#endif
