#ifndef ROADMAPUTIL_H
#define ROADMAPUTIL_H

#include <vector>

const float  inv_kT          = 1.677481737; // 300K
//const float  inv_kT          = 0.1677481737; // 3000K

class treeClass;
class Protein;

class ccInfoType
{
 public:
  ccInfoType();
  
  treeClass * globalFirstTree, * globalLastTree;
  int numTrees, globalTreeName;
  
};
void sampleGivenCoords(vector<float> & xcoords, 
		       vector<float> & ycoords, 
		       int * numberOfNodes,
		       Protein ** allNodes);

void sampleAllNodes       (int * numberOfNodes, const int numRandomNodes,
			   int * nativeNodeIndex,
			   int * unfoldedStateIndex,
			   Protein ** allNodes,
			   int MAXNODES,
			   bool totallyRandom = false);
void createRandomNodes (int * numberOfNodes, Protein ** allNodes,
		  int numNodes2Sample);

//linking 

int makeLinkBetweenNodes ( int numNodes, const int n1, const int n2, 
			   Protein ** allNodes,
			   ccInfoType * ccInfo);

unsigned int linkNodes (int numNodes, Protein ** allNodes, int k, 
			ccInfoType * ccInfo);

void addNode2Forest(int count, Protein ** allNodes, ccInfoType * ccInfo);

// transition probability computation related

unsigned int computeTransitionProbabilities(Protein ** allNodes, int numNodes);
#endif


